(* THIS IS NOT MAINTAINED IN THIS FORK -- it is never used *)

(*
From iris.algebra Require Import upred_tactics.
From iris.program_logic Require Export hoare lifting stepshifts.
From iris.program_logic Require Import ownership.
From iris.proofmode Require Import tactics pviewshifts pstepshifts.


Local Notation "{{ P } } ef ?@ E {{ v , Q } }" :=
  (default Emp%I ef (λ e, ht E P e (λ v, Q)))
  (at level 20, P, ef, Q at level 200,
   format "{{  P  } }  ef  ?@  E  {{  v ,  Q  } }") : uPred_scope.
Local Notation "{{ P } } ef ?@ E {{ v , Q } }" :=
  (Emp ⊢ default Emp ef (λ e, ht E P e (λ v, Q)))
  (at level 20, P, ef, Q at level 200,
   format "{{  P  } }  ef  ?@  E  {{  v ,  Q  } }") : C_scope.

Section lifting.
Context {Λ : language} {Σ : iFunctor}.
Context `{Inhabited (val Λ)}.
Context `{Inhabited (expr Λ)}.
Context `{Inhabited (state Λ)}.
Implicit Types e : expr Λ.
Implicit Types P Q R : iProp Λ Σ.
Implicit Types Ψ : val Λ → iProp Λ Σ.

Lemma ht_lift_step E1 E2 P Pσ1 Φ1 Φ2 Ψ e1 :
  E2 ⊆ E1 → to_val e1 = None →
<<<<<<< HEAD
  reducible e1 σ1 →
  (∀ e2 σ2 ef, prim_step e1 σ1 e2 σ2 ef → φ e2 σ2 ef) →
  (⧆(P ={E1,E2}=> ⧆▷ ownP σ1 ★ ▷ P') ★
   ⧆(∀ e2 σ2 ef, ⧆■ φ e2 σ2 ef ★ ownP σ2 ★ P' 
                 ={E2,E1}=>> Φ1 e2 σ2 ef ★ default Emp ef (λ _, Φ2 e2 σ2 ef)) ★
   ⧆(∀ e2 σ2 ef, {{ Φ1 e2 σ2 ef }} e2 @ E1 {{ Ψ }}) ★
   ⧆(∀ e2 σ2 ef, {{ Φ2 e2 σ2 ef }} ef ?@ ⊤ {{ _, uPred_stopped }}))
  ⊢ {{ P }} e1 @ E1 {{ Ψ }}.
Proof.
  iIntros {?? Hsafe Hstep}.
  apply uPred.affine_intro; first apply _.
  iIntros "#(Hvs&HΦ&He2&Hef) ! HP".
  iApply (wp_lift_step E1 E2 φ _ e1 σ1); auto.
  iPvs ("Hvs" with "! HP") as "[Hσ HP]"; first set_solver.
  iPvsIntro.
  iSplitL "Hσ".
  - iClear "Hef". iClear "He2". iClear "HΦ". auto.
  - iNext. iIntros {e2 σ2 ef} "[Hφ Hown]".
    rewrite uPred.affine_elim.
    iSpecialize ("HΦ" $! e2 σ2 ef with "! -"). 
    * iFrame "Hφ HP Hown". iClear "He2". iClear "Hef". auto.
    * iPsvs "HΦ" as "[H1 H2]"; first by set_solver.
      iPvsIntro. iSplitL "H1".
      ** iClear "Hef". rewrite uPred.affine_elim. by iApply ("He2" with "!"). 
      ** iClear "He2".
         destruct ef as [e|].
         *** rewrite uPred.affine_elim. iApply ("Hef" $! _ _ (Some e) with "!"). auto.
         *** iClear "Hef". auto.
Qed.

Lemma ht_lift_atomic_step
    E (φ : expr Λ → state Λ → option (expr Λ) → Prop) P P' e1 σ1 :
  atomic e1 →
  reducible e1 σ1 →
  (∀ e2 σ2 ef, prim_step e1 σ1 e2 σ2 ef → φ e2 σ2 ef) →
  (⧆(P ={E}=>> P') ★
   ⧆(∀ e2 σ2 ef, {{ ⧆■ φ e2 σ2 ef ★ P' }} ef ?@ ⊤ {{ _, uPred_stopped }})) ⊢
  {{ ⧆▷ ownP σ1 ★ ▷ P }} e1 @ E {{ v, ∃ σ2 ef, ownP σ2 ★ ⧆■ φ (of_val v) σ2 ef
                                                    ★ default P' ef (λ _, Emp)  }}.
Proof.
  iIntros {? Hsafe Hstep} "#(Hsvs&Hef)".
  set (φ' e σ ef := is_Some (to_val e) ∧ φ e σ ef).
  iApply (ht_lift_step E E φ'  _ P
    (λ e2 σ2 ef, ownP σ2 ★ ⧆■ (φ' e2 σ2 ef) ★ default P' ef (λ _, Emp))%I
    (λ e2 σ2 ef, ⧆■ φ e2 σ2 ef ★ P')%I);
    try by (rewrite /φ'; eauto using atomic_not_val, atomic_step).
  repeat iSplit.
  - iClear "Hef". iClear "Hsvs". apply uPred.affine_intro; first apply _. 
    iApply vs_reflexive.
  - apply uPred.affine_intro; first apply _.
    iIntros {e2 σ2 ef} "! (#Hφ&Hown&HP)". iApply psvs_pvs'.
    iPsvs ("Hsvs" with "! HP").
    iPvsIntro. iPvsIntro.
    destruct ef as [e'|].
    (* Some forked thread *)
    * iSplitL "Hown". 
      ** iClear "Hef". iSplitL "" "Hown"; simpl; rewrite ?right_id; auto.
      ** simpl. iDestruct "Hφ" as %[_ ?]. rewrite uPred.const_equiv //= -uPred.emp_True left_id.
         iClear "Hef". auto.
    * simpl. rewrite right_id. iClear "Hef". 
      iSplitL "" "Hown"; auto.
      iSplitR "" "~"; auto.
  - apply uPred.affine_intro; first apply _.
    iIntros {e2 σ2 ef}.  
    apply uPred.affine_intro; first apply _.
    iIntros "! (Hown&#Hφ&HP')".
    iDestruct "Hφ" as %[[v2 <-%of_to_val] ?].
    iApply wp_value'. iExists σ2, ef. rewrite uPred.const_equiv //= -uPred.emp_True left_id.
    iClear "Hsvs". iClear "Hef". iSplitL "Hown"; auto.
  - iClear "Hsvs". auto. 
Qed.

(* OK, I'm not sure what form would be most useful to work with, and it appears
   this is never used in any examples, so I will not fix it. *)

(*
Lemma ht_lift_pure_step E (φ : expr Λ → option (expr Λ) → Prop) Q P P' Ψ e1 :
  to_val e1 = None →
  (∀ σ1, reducible e1 σ1) →
  (∀ σ1 e2 σ2 ef, prim_step e1 σ1 e2 σ2 ef → σ1 = σ2 ∧ φ e2 ef) →
  (⧆(Q ={E}=>> P ★ P') ★
   ⧆(∀ e2 ef, {{ ⧆■ φ e2 ef ★ P }} e2 @ E {{ v, Ψ v ★ default P' ef (λ _, Emp)}}) ★
   ⧆(∀ e2 ef, {{ ⧆■ φ e2 ef ★ P' }} ef ?@ ⊤ {{ _, uPred_stopped }}))
  ⊢ {{ ▷ Q }} e1 @ E {{ Ψ }}.
Proof.
  iIntros {? Hsafe Hstep} "#Hpre".
  apply uPred.affine_intro; first apply _.
  iDestruct "Hpre" as "(Hsvs&He2&Hef)". 
  iIntros "! HQ".
  iApply (wp_lift_pure_step E φ _ e1); auto.
  iNext; iIntros {e2 ef Hφ}. 
  iApply psvs_pvs'.
  iSpecialize ("Hsvs" with "! HQ").
  iPsvs "Hsvs" as "(HP&HP')". iPvsIntro.
  destruct ef as [e'|].
  - iSplitL "HP".
    * iClear "Hef". rewrite uPred.affine_elim.
      iSpecialize ("He2" $! e2 (Some e') with "! -"); simpl; auto.
      ** rewrite uPred.const_equiv //=. rewrite -uPred.emp_True ?left_id. auto. 
      ** iPvsIntro. 
         transitivity (WP e2 @ E {{ v, Ψ v ★ Emp }})%I; first auto.
         apply wp_mono=>v. rewrite ?right_id. auto.
    *  simpl. iClear "He2".
       rewrite uPred.affine_elim.
       iSpecialize ("Hef" $! e2 (Some e') with "! -"); simpl; auto.
      ** rewrite uPred.const_equiv //=. rewrite -uPred.emp_True ?left_id. auto. 
      ** iPvsIntro. auto.
  - simpl. rewrite ?right_id. iClear "Hef".
    rewrite uPred.affine_elim.
    iSpecialize ("He2" $! e2 None with "! -"); simpl; auto.
     * simpl.
      iSpecialize ("He2" with "!").
      iSpecialize ("He2" $! e2 e').
 e2.
 iApply ("He2" with "! e2 ").
 simpl.  iPvsIntro. split
  `
  iPsvs.

iDestruct "HP" as "[HP HP']"; iSplitL "HP".
  - iApply ("He2" with "!"); by iSplit.
  - destruct ef as [e|]; last done.
    iApply ("Hef" $! _ (Some e) with "!"); by iSplit.
=======
  (P ={E1,E2}=> ∃ σ1, ■ reducible e1 σ1 ∧ ▷ ownP σ1 ★ ▷ Pσ1 σ1) ∧
    (∀ σ1 e2 σ2 ef, ■ prim_step e1 σ1 e2 σ2 ef ★ ownP σ2 ★ Pσ1 σ1
                  ={E2,E1}=> Φ1 e2 σ2 ef ★ Φ2 e2 σ2 ef) ∧
    (∀ e2 σ2 ef, {{ Φ1 e2 σ2 ef }} e2 @ E1 {{ Ψ }}) ∧
    (∀ e2 σ2 ef, {{ Φ2 e2 σ2 ef }} ef ?@ ⊤ {{ _, True }})
  ⊢ {{ P }} e1 @ E1 {{ Ψ }}.
Proof.
  iIntros (??) "#(#Hvs&HΦ&He2&Hef) ! HP".
  iApply (wp_lift_step E1 E2 _ e1); auto.
  iPvs ("Hvs" with "HP") as (σ1) "(%&Hσ&HP)"; first set_solver.
  iPvsIntro. iExists σ1. repeat iSplit. by eauto. iFrame.
  iNext. iIntros (e2 σ2 ef) "[#Hstep Hown]".
  iSpecialize ("HΦ" $! σ1 e2 σ2 ef with "[-]"). by iFrame "Hstep HP Hown".
  iPvs "HΦ" as "[H1 H2]"; first by set_solver. iPvsIntro. iSplitL "H1".
  - by iApply "He2".
  - destruct ef as [e|]; last done. by iApply ("Hef" $! _ _ (Some e)).
Qed.

Lemma ht_lift_atomic_step E P e1 σ1 :
  atomic e1 →
  reducible e1 σ1 →
  (∀ e2 σ2 ef, {{ ■ prim_step e1 σ1 e2 σ2 ef ★ P }} ef ?@ ⊤ {{ _, True }}) ⊢
  {{ ▷ ownP σ1 ★ ▷ P }} e1 @ E {{ v, ∃ σ2 ef, ownP σ2
                                       ★ ■ prim_step e1 σ1 (of_val v) σ2 ef }}.
Proof.
  iIntros (? Hsafe) "#Hef".
  iApply (ht_lift_step E E _ (λ σ1', P ∧ σ1 = σ1')%I
           (λ e2 σ2 ef, ownP σ2 ★ ■ (is_Some (to_val e2) ∧ prim_step e1 σ1 e2 σ2 ef))%I
           (λ e2 σ2 ef, ■ prim_step e1 σ1 e2 σ2 ef ★ P)%I);
    try by (eauto using atomic_not_val).
  repeat iSplit.
  - iIntros "![Hσ1 HP]". iExists σ1. iPvsIntro.
    iSplit. by eauto using atomic_step. iFrame. by auto.
  - iIntros (? e2 σ2 ef) "! (%&Hown&HP&%)". iPvsIntro. subst.
    iFrame. iSplit; iPureIntro; auto. split; eauto using atomic_step.
  - iIntros (e2 σ2 ef) "! [Hown #Hφ]"; iDestruct "Hφ" as %[[v2 <-%of_to_val] ?].
    iApply wp_value'. iExists σ2, ef. by iSplit.
  - done.
Qed.

Lemma ht_lift_pure_step E P P' Ψ e1 :
  to_val e1 = None →
  (∀ σ1, reducible e1 σ1) →
  (∀ σ1 e2 σ2 ef, prim_step e1 σ1 e2 σ2 ef → σ1 = σ2) →
  (∀ e2 ef σ, {{ ■ prim_step e1 σ e2 σ ef ★ P }} e2 @ E {{ Ψ }}) ∧
    (∀ e2 ef σ, {{ ■ prim_step e1 σ e2 σ ef ★ P' }} ef ?@ ⊤ {{ _, True }})
  ⊢ {{ ▷(P ★ P') }} e1 @ E {{ Ψ }}.
Proof.
  iIntros (? Hsafe Hpure) "[#He2 #Hef] ! HP". iApply wp_lift_pure_step; auto.
  iNext; iIntros (e2 ef σ Hstep). iDestruct "HP" as "[HP HP']"; iSplitL "HP".
  - iApply "He2"; by iSplit.
  - destruct ef as [e|]; last done. iApply ("Hef" $! _ (Some e)); by iSplit.
>>>>>>> upstream/master
Qed.
*)

<<<<<<< HEAD
(* Same remark as above *)
(*
Lemma ht_lift_pure_det_step
    E (φ : expr Λ → option (expr Λ) → Prop) P P' Ψ e1 e2 ef :
=======
Lemma ht_lift_pure_det_step E P P' Ψ e1 e2 ef :
>>>>>>> upstream/master
  to_val e1 = None →
  (∀ σ1, reducible e1 σ1) →
  (∀ σ1 e2' σ2 ef', prim_step e1 σ1 e2' σ2 ef' → σ1 = σ2 ∧ e2 = e2' ∧ ef = ef')→
  {{ P }} e2 @ E {{ Ψ }} ∧ {{ P' }} ef ?@ ⊤ {{ _, True }}
  ⊢ {{ ▷(P ★ P') }} e1 @ E {{ Ψ }}.
Proof.
  iIntros (? Hsafe Hpuredet) "[#He2 #Hef]".
  iApply ht_lift_pure_step; eauto. by intros; eapply Hpuredet.
  iSplit; iIntros (e2' ef' σ).
  - iIntros "! [% ?]". edestruct Hpuredet as (_&->&->). done. by iApply "He2".
  - destruct ef' as [e'|]; last done.
    iIntros "! [% ?]". edestruct Hpuredet as (_&->&->). done. by iApply "Hef".
Qed.
*)
End lifting.
*)